function  [L,U]=fatt_lu(A)
% funzione che ci restituisce la fattorizzazione LU di A.

n = length(A);  % dimensione della matrice
L = eye(n);     % pre-definisco L
U = zeros(n);   % predefinisco  U 

U(1,:) = A(1,:); % prima riga di U.
for i = 2:n
  % riga i-esima di L.
  for j= 1:i-1
     L(i,j) =1/U(j,j)*(A(i,j) - L(i,1:j-1)*U(1:j-1,j));   % l_ij = 1/u_jj(a_ij - sum_(k=1)^(j-1) l_ik*u_kj)
  end
  % riga i-esima di U.
  for j= i:n
     U(i,j) = A(i,j) - L(i,1:i-1)*U(1:i-1,j);       % u_ij = a_ij - sum_(k=1)^(i-1) l_ik*u_kj)
  end
end

end
