clear all
close all 
% 
% A  = [4 -1   1  0; 
%       1 -1/4 0  1; 
%      -1  0   0  1; 
%       0  1   2  1];
% b  = [1  2   3  4]'; 
A = randn(100);
b = randn(100,1);


if det(A)==0
  disp('Matrice singolare!!')
  return
end

n = length(A);  % dimensione della matrice

[L, U, P] = fatt_lu_pr(A);  % fattorizzazione LU

% A x = b;  sistema da risolvere LUx = b; che si scompone come:
y  = forward(L,P*b);  % Ly  = P*b;     risoluzione forward
x  = backward(U,y);   % Ux  = y;     risoluzione backward 

% check della soluzione:
A*x - b


% Octave ha gi? una funzione per la fattorizzazione LU ovvero:

[Lo, Uo, Po] = lu(A);



%% -Esercizi:
%
% 1: Utilizzare il codice per una matrice qualsiasi : 
% A  = randn(10);
% b  = randn(10,1);  
% verificare che A*x - b non ? esattamente zero. Come mai?


% 2: Scrivere un ciclo for che seleziona solo i numeri dispari 'n' da 1 a 100 
%    e che ad ogni iterazione risolva il sistema Ax = b, tramite
%    fattorizzazione LU, dove A = magic(n) e b = sum(A,2); 
%    notare che in questo modo la soluzione esatta x ? il vettore di tutti 1,
%    ( x = ones(n,1)).
%     
%    - Si salvi ad ogni iterazione il valore del numero di condizionamento di A
%      e l'errore assoluto in norma 1 che si commette nel calcolo di A*x-b,
%      in due vettori condA e errA.
%    - si disegni in scala semilogaritmica l'andamento di condA e errA all'aumentare delle
%    iterazioni.
%    - discutere il risultato.

