function   [kp] = K_cond(A,p)
% p e' un numero 1 o 0
% - se p e' 1 ho la norma 1 
% - se p e' 0 ho la norma infinito
% - se p e' 2 ho la norma 2
switch p
    case 0 % norma infinito
            N_inf1 = max(sum(abs(A)));
            N_inf2 = max(sum(abs(inv(A))));
            kp  = N_inf1*N_inf2; 
    case 1 % norma uno
            N_l11 = max(sum(abs(A),2));
            N_l12 = max(sum(abs(inv(A)),2));
            kp  = N_l11*N_l12;
    case 2 
           kp = cond(A);
end


end