% Metodo eliminazione di Gauss:

clear all
close all 

A  = [4  3   2  1; 
      1  2   1  1; 
      0  1   0  1; 
      1  1   2  1];

b  = [1  2   3  4]'; 

n = length(A);


U = A; % inizializzo la matrice U triadiag sup;
c = b; % inizializzo il vettore dei termini noti modificati
k = 1; % indice della riga pivotale 

A;
E = zeros(n);    % inizializzazione degli elementi che cancellano la parte inferiore di A.
L = eye(n);      % inizializzazione della matrice tridagonale inferiore L.

for k=1:n-1
for i = k+1:n
    E(i,k)      = U(i,k)/U(k,k);        % definisco l'elemento pivotale
    for j = 1:n
        U(i,j) = U(i,j) - E(i,k)*U(k,j); % eliminazione di Gauss.
    end
         c(i) = c(i) - E(i,k)*c(k);      % aggiorno il vettore dei termini noti.
    end
end

% esercizio: risolvere il sistema tridiagonale superiore dato da Ux = c
%  usando un comando ciclo for.

x = zeros(n,1); % vettore soluzione

x(n) = c(n)/U(n,n);
for k = n-1:-1:1
    x(k) = (c(k)- U(k,k+1:n)*x(k+1:n))/U(k,k);
end

% errore
errA = sum(abs(A*x-b))

% esercizio scrivere i comandi che risolvono un sistema tridiagonale inferiore, come esempio utilizzare
% Ly = b;
% y = zeros(n,1);
% y(1) = b(1)/L(1,1);
% for k = 2:n
%    y(k) = (b(k)- L(k,1:k-1)*y(1:k-1))/L(k,k);
% end


%% Esercizi: 

% 1- calcolarsi il determinate di A come il prodotto degli elementi sulla diagonale di U. 
% E verificare tramite il comando det(A) e det(U) che questi valori coincidono.
%
% 2-  usiamo questa informazione per calcolare l'inversa di A, usando la formula con i cofattori.
% verificare che  L'inversa ottenuta coincida con inv(A)
%

% 3 - scrivere un codice per l'eliminazione di Gauss utilizzando lo step fondamentale precedente,
% e  vi restituisca una matrice U tridagonale superiore e L triangolare inferiore.







