function  [B,P]=permutazione(B,i,j,d)

[n, ~] = size(B);                % dimesione A.
  
P      = eye(n);

if (nargin == 3 || d == 1)

  mA     = B(i,:);              % mi salvo in mA la riga i-esima   
  B(i,:) = B(j,:);              % sostituisco la riga  i con la riga j  
  B(j,:) = mA;                  % sostituisco la riga j con la riga i

  mP         = P(i,:);          % identifichiamo la riga i-esima di P
  P(i,:)     = P(j,:);          % permutiamo le righe i e j;
  P(j,:)     = mP;
else 

  mA     = B(:,i);              % mi salvo in mA la riga i-esima   
  B(:,i) = B(:,j);              % sostituisco la riga  i con la riga j  
  B(:,j) = mA;                  % sostituisco la riga j con la riga i

  mP         = P(:,i);          % identifichiamo la riga i-esima di P
  P(:,i)     = P(:,j);          % permutiamo le righe i e j;
  P(:,j)     = mP;


end


% Esercizio:  
% definire un parametro in input 'd' che determini se fare la permutazione per righe o per colonne.
% ( utilizzare il comando nargin in modo tale da poter dare in input anche solo 3 elementi, nel % qualcaso operare la permutazione per righe)
